Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 1014)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 1015)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-!
+! new branch prognostic_equations_acc
+! OpenACC statements added + code changes required for GPU optimization
 !
 ! Former revisions:
@@ -136,5 +137,5 @@
     PRIVATE
     PUBLIC prognostic_equations_noopt, prognostic_equations_cache, &
-           prognostic_equations_vector
+           prognostic_equations_vector, prognostic_equations_acc
 
     INTERFACE prognostic_equations_noopt
@@ -149,4 +150,8 @@
        MODULE PROCEDURE prognostic_equations_vector
     END INTERFACE prognostic_equations_vector
+
+    INTERFACE prognostic_equations_acc
+       MODULE PROCEDURE prognostic_equations_acc
+    END INTERFACE prognostic_equations_acc
 
 
@@ -1900,3 +1905,582 @@
 
 
+ SUBROUTINE prognostic_equations_acc
+
+!------------------------------------------------------------------------------!
+! Version for accelerator boards
+!------------------------------------------------------------------------------!
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=9) ::  time_to_string
+    INTEGER ::  i, j, k, runge_step
+    REAL    ::  sbt
+
+!
+!-- Set switch for intermediate Runge-Kutta step
+    runge_step = 0
+    IF ( timestep_scheme(1:5) == 'runge' )  THEN
+       IF ( intermediate_timestep_count == 1 )  THEN
+          runge_step = 1
+       ELSEIF ( intermediate_timestep_count < &
+                intermediate_timestep_count_max )  THEN
+          runge_step = 2
+       ENDIF
+    ENDIF
+
+!
+!-- Calculate those variables needed in the tendency terms which need
+!-- global communication
+    IF ( .NOT. neutral )  CALL calc_mean_profile( pt, 4 )
+    IF ( ocean         )  CALL calc_mean_profile( rho, 64 )
+    IF ( humidity      )  CALL calc_mean_profile( vpt, 44 )
+    IF ( ( ws_scheme_mom .OR. ws_scheme_sca )  .AND.  &
+         intermediate_timestep_count == 1 )  CALL ws_statistics
+
+!
+!-- u-velocity component
+!++ Statistics still not ported to accelerators
+    !$acc update device( hom )
+    CALL cpu_log( log_point(5), 'u-equation', 'start' )
+
+    IF ( timestep_scheme(1:5) == 'runge' )  THEN
+       IF ( ws_scheme_mom )  THEN
+          CALL advec_u_ws_acc
+       ELSE
+          tend = 0.0    ! to be removed later??
+          CALL advec_u_pw
+       ENDIF
+    ELSE
+       CALL advec_u_up
+    ENDIF
+    CALL diffusion_u_acc
+    CALL coriolis_acc( 1 )
+    IF ( sloping_surface  .AND.  .NOT. neutral )  THEN
+       CALL buoyancy( pt, pt_reference, 1, 4 )
+    ENDIF
+
+!
+!-- Drag by plant canopy
+    IF ( plant_canopy )  CALL plant_canopy_model( 1 )
+
+!
+!-- External pressure gradient
+    IF ( dp_external )  THEN
+       DO  i = nxlu, nxr
+          DO  j = nys, nyn
+             DO  k = dp_level_ind_b+1, nzt
+                tend(k,j,i) = tend(k,j,i) - dpdxy(1) * dp_smooth_factor(k)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+
+    CALL user_actions( 'u-tendency' )
+
+!
+!-- Prognostic equation for u-velocity component
+    !$acc kernels present( nzb_u_inner, rdf, tend, tu_m, u, ug, u_p )
+    !$acc loop
+    DO  i = nxlu, nxr
+       DO  j = nys, nyn
+          !$acc loop vector( 32 )
+          DO  k = 1, nzt
+             IF ( k > nzb_u_inner(j,i) )  THEN
+                u_p(k,j,i) = u(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
+                                                  tsc(3) * tu_m(k,j,i) )       &
+                                      - tsc(5) * rdf(k) * ( u(k,j,i) - ug(k) )
+!
+!--             Tendencies for the next Runge-Kutta step
+                IF ( runge_step == 1 )  THEN
+                   tu_m(k,j,i) = tend(k,j,i)
+                ELSEIF ( runge_step == 2 )  THEN
+                   tu_m(k,j,i) = -9.5625 * tend(k,j,i) + 5.3125 * tu_m(k,j,i)
+                ENDIF
+             ENDIF
+          ENDDO
+       ENDDO
+    ENDDO
+    !$acc end kernels
+
+    CALL cpu_log( log_point(5), 'u-equation', 'stop' )
+    !$acc update host( u_p )
+
+!
+!-- v-velocity component
+    CALL cpu_log( log_point(6), 'v-equation', 'start' )
+
+    IF ( timestep_scheme(1:5) == 'runge' )  THEN
+       IF ( ws_scheme_mom )  THEN
+          CALL advec_v_ws_acc
+       ELSE
+          tend = 0.0    ! to be removed later??
+          CALL advec_v_pw
+       END IF
+    ELSE
+       CALL advec_v_up
+    ENDIF
+    CALL diffusion_v_acc
+    CALL coriolis_acc( 2 )
+
+!
+!-- Drag by plant canopy
+    IF ( plant_canopy )  CALL plant_canopy_model( 2 )
+
+!
+!-- External pressure gradient
+    IF ( dp_external )  THEN
+       DO  i = nxl, nxr
+          DO  j = nysv, nyn
+             DO  k = dp_level_ind_b+1, nzt
+                tend(k,j,i) = tend(k,j,i) - dpdxy(2) * dp_smooth_factor(k)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+
+    CALL user_actions( 'v-tendency' )
+
+!
+!-- Prognostic equation for v-velocity component
+    !$acc kernels present( nzb_v_inner, rdf, tend, tv_m, v, vg, v_p )
+    !$acc loop
+    DO  i = nxl, nxr
+       DO  j = nysv, nyn
+          !$acc loop vector( 32 )
+          DO  k = 1, nzt
+             IF ( k > nzb_v_inner(j,i) )  THEN
+                v_p(k,j,i) = v(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
+                                                  tsc(3) * tv_m(k,j,i) )       &
+                                      - tsc(5) * rdf(k) * ( v(k,j,i) - vg(k) )
+!
+!--             Tendencies for the next Runge-Kutta step
+                IF ( runge_step == 1 )  THEN
+                   tv_m(k,j,i) = tend(k,j,i)
+                ELSEIF ( runge_step == 2 )  THEN
+                   tv_m(k,j,i) = -9.5625 * tend(k,j,i) + 5.3125 * tv_m(k,j,i)
+                ENDIF
+             ENDIF
+          ENDDO
+       ENDDO
+    ENDDO
+    !$acc end kernels
+
+    CALL cpu_log( log_point(6), 'v-equation', 'stop' )
+    !$acc update host( v_p )
+
+!
+!-- w-velocity component
+    CALL cpu_log( log_point(7), 'w-equation', 'start' )
+
+    IF ( timestep_scheme(1:5) == 'runge' )  THEN
+       IF ( ws_scheme_mom )  THEN
+          CALL advec_w_ws_acc
+       ELSE
+          tend = 0.0    ! to be removed later??
+          CALL advec_w_pw
+       ENDIF
+    ELSE
+       CALL advec_w_up
+    ENDIF
+    CALL diffusion_w_acc
+    CALL coriolis_acc( 3 )
+
+    IF ( .NOT. neutral )  THEN
+       IF ( ocean )  THEN
+          CALL buoyancy( rho, rho_reference, 3, 64 )
+       ELSE
+          IF ( .NOT. humidity )  THEN
+             CALL buoyancy_acc( pt, pt_reference, 3, 4 )
+          ELSE
+             CALL buoyancy( vpt, pt_reference, 3, 44 )
+          ENDIF
+       ENDIF
+    ENDIF
+
+!
+!-- Drag by plant canopy
+    IF ( plant_canopy )  CALL plant_canopy_model( 3 )
+
+    CALL user_actions( 'w-tendency' )
+
+!
+!-- Prognostic equation for w-velocity component
+    !$acc kernels present( nzb_w_inner, rdf, tend, tw_m, w, w_p )
+    !$acc loop
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          !$acc loop vector( 32 )
+          DO  k = 1, nzt-1
+             IF ( k > nzb_w_inner(j,i) )  THEN
+                w_p(k,j,i) = w(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
+                                                  tsc(3) * tw_m(k,j,i) )       &
+                                      - tsc(5) * rdf(k) * w(k,j,i)
+   !
+   !--          Tendencies for the next Runge-Kutta step
+                IF ( runge_step == 1 )  THEN
+                   tw_m(k,j,i) = tend(k,j,i)
+                ELSEIF ( runge_step == 2 )  THEN
+                   tw_m(k,j,i) = -9.5625 * tend(k,j,i) + 5.3125 * tw_m(k,j,i)
+                ENDIF
+             ENDIF
+          ENDDO
+       ENDDO
+    ENDDO
+    !$acc end kernels
+
+    CALL cpu_log( log_point(7), 'w-equation', 'stop' )
+    !$acc update host( w_p )
+
+
+!
+!-- If required, compute prognostic equation for potential temperature
+    IF ( .NOT. neutral )  THEN
+
+       CALL cpu_log( log_point(13), 'pt-equation', 'start' )
+
+!
+!--    pt-tendency terms with communication
+       sbt = tsc(2)
+       IF ( scalar_advec == 'bc-scheme' )  THEN
+
+          IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+!
+!--          Bott-Chlond scheme always uses Euler time step. Thus:
+             sbt = 1.0
+          ENDIF
+          tend = 0.0
+          CALL advec_s_bc( pt, 'pt' )
+
+       ENDIF
+
+!
+!--    pt-tendency terms with no communication
+       IF ( scalar_advec /= 'bc-scheme' )  THEN
+          tend = 0.0
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( ws_scheme_sca )  THEN
+                CALL advec_s_ws_acc( pt, 'pt' )
+             ELSE
+                tend = 0.0    ! to be removed later??
+                CALL advec_s_pw( pt )
+             ENDIF
+          ELSE
+             CALL advec_s_up( pt )
+          ENDIF
+       ENDIF
+
+       CALL diffusion_s_acc( pt, shf, tswst, wall_heatflux )
+
+!
+!--    If required compute heating/cooling due to long wave radiation processes
+       IF ( radiation )  THEN
+          CALL calc_radiation
+       ENDIF
+
+!
+!--    If required compute impact of latent heat due to precipitation
+       IF ( precipitation )  THEN
+          CALL impact_of_latent_heat
+       ENDIF
+
+!
+!--    Consideration of heat sources within the plant canopy
+       IF ( plant_canopy .AND. ( cthf /= 0.0 ) ) THEN
+          CALL plant_canopy_model( 4 )
+       ENDIF
+
+!
+!--    If required compute influence of large-scale subsidence/ascent
+       IF ( large_scale_subsidence )  THEN
+          CALL subsidence( tend, pt, pt_init )
+       ENDIF
+
+       CALL user_actions( 'pt-tendency' )
+
+!
+!--    Prognostic equation for potential temperature
+       !$acc kernels present( nzb_s_inner, rdf_sc, ptdf_x, ptdf_y, pt_init ) &
+       !$acc         present( tend, tpt_m, pt, pt_p )
+       !$acc loop
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             !$acc loop vector( 32 )
+             DO  k = 1, nzt
+                IF ( k > nzb_s_inner(j,i) )  THEN
+                   pt_p(k,j,i) = pt(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +        &
+                                                       tsc(3) * tpt_m(k,j,i) )    &
+                                           - tsc(5) * ( pt(k,j,i) - pt_init(k) ) *&
+                                             ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )
+!
+!--                Tendencies for the next Runge-Kutta step
+                   IF ( runge_step == 1 )  THEN
+                      tpt_m(k,j,i) = tend(k,j,i)
+                   ELSEIF ( runge_step == 2 )  THEN
+                      tpt_m(k,j,i) = -9.5625 * tend(k,j,i) + 5.3125 * tpt_m(k,j,i)
+                   ENDIF
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+       !$acc end kernels
+
+       CALL cpu_log( log_point(13), 'pt-equation', 'stop' )
+       !$acc update host( pt_p )
+
+    ENDIF
+
+!
+!-- If required, compute prognostic equation for salinity
+    IF ( ocean )  THEN
+
+       CALL cpu_log( log_point(37), 'sa-equation', 'start' )
+
+!
+!--    sa-tendency terms with communication
+       sbt = tsc(2)
+       IF ( scalar_advec == 'bc-scheme' )  THEN
+
+          IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+!
+!--          Bott-Chlond scheme always uses Euler time step. Thus:
+             sbt = 1.0
+          ENDIF
+          tend = 0.0
+          CALL advec_s_bc( sa, 'sa' )
+
+       ENDIF
+
+!
+!--    sa-tendency terms with no communication
+       IF ( scalar_advec /= 'bc-scheme' )  THEN
+          tend = 0.0
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( ws_scheme_sca )  THEN
+                 CALL advec_s_ws( sa, 'sa' )
+             ELSE
+                 CALL advec_s_pw( sa )
+             ENDIF
+          ELSE
+             CALL advec_s_up( sa )
+          ENDIF
+       ENDIF
+
+       CALL diffusion_s( sa, saswsb, saswst, wall_salinityflux )
+
+       CALL user_actions( 'sa-tendency' )
+
+!
+!--    Prognostic equation for salinity
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
+                sa_p(k,j,i) = sa(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +        &
+                                                    tsc(3) * tsa_m(k,j,i) )    &
+                                        - tsc(5) * rdf_sc(k) *                 &
+                                          ( sa(k,j,i) - sa_init(k) )
+                IF ( sa_p(k,j,i) < 0.0 )  sa_p(k,j,i) = 0.1 * sa(k,j,i)
+!
+!--             Tendencies for the next Runge-Kutta step
+                IF ( runge_step == 1 )  THEN
+                   tsa_m(k,j,i) = tend(k,j,i)
+                ELSEIF ( runge_step == 2 )  THEN
+                   tsa_m(k,j,i) = -9.5625 * tend(k,j,i) + 5.3125 * tsa_m(k,j,i)
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+
+       CALL cpu_log( log_point(37), 'sa-equation', 'stop' )
+
+!
+!--    Calculate density by the equation of state for seawater
+       CALL cpu_log( log_point(38), 'eqns-seawater', 'start' )
+       CALL eqn_state_seawater
+       CALL cpu_log( log_point(38), 'eqns-seawater', 'stop' )
+
+    ENDIF
+
+!
+!-- If required, compute prognostic equation for total water content / scalar
+    IF ( humidity  .OR.  passive_scalar )  THEN
+
+       CALL cpu_log( log_point(29), 'q/s-equation', 'start' )
+
+!
+!--    Scalar/q-tendency terms with communication
+       sbt = tsc(2)
+       IF ( scalar_advec == 'bc-scheme' )  THEN
+
+          IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+!
+!--          Bott-Chlond scheme always uses Euler time step. Thus:
+             sbt = 1.0
+          ENDIF
+          tend = 0.0
+          CALL advec_s_bc( q, 'q' )
+
+       ENDIF
+
+!
+!--    Scalar/q-tendency terms with no communication
+       IF ( scalar_advec /= 'bc-scheme' )  THEN
+          tend = 0.0
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( ws_scheme_sca )  THEN
+                CALL advec_s_ws( q, 'q' )
+             ELSE
+                CALL advec_s_pw( q )
+             ENDIF
+          ELSE
+             CALL advec_s_up( q )
+          ENDIF
+       ENDIF
+
+       CALL diffusion_s( q, qsws, qswst, wall_qflux )
+
+!
+!--    If required compute decrease of total water content due to
+!--    precipitation
+       IF ( precipitation )  THEN
+          CALL calc_precipitation
+       ENDIF
+
+!
+!--    Sink or source of scalar concentration due to canopy elements
+       IF ( plant_canopy ) CALL plant_canopy_model( 5 )
+
+!
+!--    If required compute influence of large-scale subsidence/ascent
+       IF ( large_scale_subsidence )  THEN
+         CALL subsidence( tend, q, q_init )
+       ENDIF
+
+       CALL user_actions( 'q-tendency' )
+
+!
+!--    Prognostic equation for total water content / scalar
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
+                q_p(k,j,i) = q(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +          &
+                                                  tsc(3) * tq_m(k,j,i) )       &
+                                      - tsc(5) * rdf_sc(k) *                   &
+                                        ( q(k,j,i) - q_init(k) )
+                IF ( q_p(k,j,i) < 0.0 )  q_p(k,j,i) = 0.1 * q(k,j,i)
+!
+!--             Tendencies for the next Runge-Kutta step
+                IF ( runge_step == 1 )  THEN
+                   tq_m(k,j,i) = tend(k,j,i)
+                ELSEIF ( runge_step == 2 )  THEN
+                   tq_m(k,j,i) = -9.5625 * tend(k,j,i) + 5.3125 * tq_m(k,j,i)
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+
+       CALL cpu_log( log_point(29), 'q/s-equation', 'stop' )
+
+    ENDIF
+
+!
+!-- If required, compute prognostic equation for turbulent kinetic
+!-- energy (TKE)
+    IF ( .NOT. constant_diffusion )  THEN
+
+       CALL cpu_log( log_point(16), 'tke-equation', 'start' )
+
+!
+!--    TKE-tendency terms with communication
+       CALL production_e_init
+
+       sbt = tsc(2)
+       IF ( .NOT. use_upstream_for_tke )  THEN
+          IF ( scalar_advec == 'bc-scheme' )  THEN
+
+             IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+!
+!--             Bott-Chlond scheme always uses Euler time step. Thus:
+                sbt = 1.0
+             ENDIF
+             tend = 0.0
+             CALL advec_s_bc( e, 'e' )
+
+          ENDIF
+       ENDIF
+
+!
+!--    TKE-tendency terms with no communication
+       IF ( scalar_advec /= 'bc-scheme'  .OR.  use_upstream_for_tke )  THEN
+          IF ( use_upstream_for_tke )  THEN
+             tend = 0.0
+             CALL advec_s_up( e )
+          ELSE
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                IF ( ws_scheme_sca )  THEN
+                   CALL advec_s_ws_acc( e, 'e' )
+                ELSE
+                   tend = 0.0    ! to be removed later??
+                   CALL advec_s_pw( e )
+                ENDIF
+             ELSE
+                tend = 0.0    ! to be removed later??
+                CALL advec_s_up( e )
+             ENDIF
+          ENDIF
+       ENDIF
+
+       IF ( .NOT. humidity )  THEN
+          IF ( ocean )  THEN
+             CALL diffusion_e( prho, prho_reference )
+          ELSE
+             CALL diffusion_e_acc( pt, pt_reference )
+          ENDIF
+       ELSE
+          CALL diffusion_e( vpt, pt_reference )
+       ENDIF
+
+       CALL production_e_acc
+
+!
+!--    Additional sink term for flows through plant canopies
+       IF ( plant_canopy )  CALL plant_canopy_model( 6 )
+       CALL user_actions( 'e-tendency' )
+
+!
+!--    Prognostic equation for TKE.
+!--    Eliminate negative TKE values, which can occur due to numerical
+!--    reasons in the course of the integration. In such cases the old TKE
+!--    value is reduced by 90%.
+       !$acc kernels present( e, e_p, nzb_s_inner, tend, te_m )
+       !$acc loop
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             !$acc loop vector( 32 )
+             DO  k = 1, nzt
+                IF ( k > nzb_s_inner(j,i) )  THEN
+                   e_p(k,j,i) = e(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +          &
+                                                     tsc(3) * te_m(k,j,i) )
+                   IF ( e_p(k,j,i) < 0.0 )  e_p(k,j,i) = 0.1 * e(k,j,i)
+!
+!--                Tendencies for the next Runge-Kutta step
+                   IF ( runge_step == 1 )  THEN
+                      te_m(k,j,i) = tend(k,j,i)
+                   ELSEIF ( runge_step == 2 )  THEN
+                      te_m(k,j,i) = -9.5625 * tend(k,j,i) + 5.3125 * te_m(k,j,i)
+                   ENDIF
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+       !$acc end kernels
+
+       CALL cpu_log( log_point(16), 'tke-equation', 'stop' )
+       !$acc update host( e_p )
+
+    ENDIF
+
+
+ END SUBROUTINE prognostic_equations_acc
+
+
  END MODULE prognostic_equations_mod
Index: /palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- /palm/trunk/SOURCE/read_var_list.f90	(revision 1014)
+++ /palm/trunk/SOURCE/read_var_list.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! ------------------
-!
+! -adjust_mixing_length
 !
 ! Former revisions:
@@ -228,6 +228,4 @@
        SELECT CASE ( TRIM( variable_chr ) )
 
-          CASE ( 'adjust_mixing_length' )
-             READ ( 13 )  adjust_mixing_length
           CASE ( 'advected_distance_x' )
              READ ( 13 )  advected_distance_x
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 1014)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-!
+! +call of prognostic_equations_acc
 !
 ! Former revisions:
@@ -176,4 +176,6 @@
           IF ( loop_optimization == 'vector' )  THEN
              CALL prognostic_equations_vector
+          ELSEIF ( loop_optimization == 'acc' )  THEN
+             CALL prognostic_equations_acc
           ELSE
              IF ( scalar_advec == 'bc-scheme' )  THEN
@@ -284,12 +286,23 @@
              CALL pres
           ENDIF
+!
+!--       Update device memory for calculating diffusion quantities and for next
+!--       timestep
+          !$acc update device( e, pt, u, v, w )
+          !$acc update device( q )  if ( allocated( q ) )
 
 !
 !--       If required, compute virtuell potential temperature
-          IF ( humidity ) CALL compute_vpt
+          IF ( humidity )  THEN
+             CALL compute_vpt
+             !$acc update device( vpt )
+          ENDIF
 
 !
 !--       If required, compute liquid water content
-          IF ( cloud_physics ) CALL calc_liquid_water_content
+          IF ( cloud_physics )  THEN
+             CALL calc_liquid_water_content
+             !$acc update device( ql )
+          ENDIF
 
 !
@@ -303,4 +316,7 @@
                 CALL prandtl_fluxes
                 CALL cpu_log( log_point(19), 'prandtl_fluxes', 'stop' )
+!
+!++             Statistics still require updates on host
+                !$acc update host( qs, qsws, rif, shf, ts )
              ENDIF
 
@@ -318,4 +334,7 @@
              ENDIF
              CALL cpu_log( log_point(17), 'diffusivities', 'stop' )
+!
+!++          Statistics still require update of diffusivities on host
+             !$acc update host( kh, km )
 
           ENDIF
